USE SBS_OLAP
GO
ALTER PROC dbo.CustomerDimUpdateValues @BatchID INT AS
UPDATE CustomerDim 
  SET CustomerCode = cs.CustomerCode
	,CustomerName = cs.CustomerName
	,BillAddress = cs.BillAddress
	,BillCity = cs.BillCity
	,BillRegion = cs.BillRegion
	,BillPostalCode = cs.BillPostalCode
	,BillCountry = cs.BillCountry
	,ShipAddress = cs.ShipAddress
	,ShipCity = cs.ShipCity
	,ShipRegion = cs.ShipRegion
	,ShipPostalCode = cs.ShipPostalCode
	,ShipCountry = cs.ShipCountry
	, BatchID = @BatchID
FROM dbo.CustomerStage as cs
INNER JOIN dbo.CustomerDim as cd
ON cs.CustomerCode = cd.CustomerCode 
WHERE cs.CustomerCode IN (SELECT cd.CustomerCode FROM CustomerDim)
INSERT INTO AuditEvents (BatchID, PackageName, StepName, 
	AdditionalInformation, RowsComplete)
	VALUES (@BatchID, 'UpdateCustomerDim', 'UpdateExistingCustData', 'Completed', @@Rowcount)
GO
ALTER  PROC dbo.CustomerDimInsertValues @BatchID INT AS
INSERT INTO CustomerDim (CustomerCode, CustomerName, BillAddress, BillCity
   ,BillRegion, BillPostalCode, BillCountry, ShipAddress
   ,ShipCity, ShipRegion, ShipPostalCode, ShipCountry, BatchID)
  SELECT cs.CustomerCode, cs.CustomerName, cs.BillAddress, cs.BillCity
   ,cs.BillRegion, cs.BillPostalCode, cs.BillCountry, cs.ShipAddress
   ,cs.ShipCity, cs.ShipRegion, cs.ShipPostalCode, cs.ShipCountry, @batchID 
FROM CustomerStage as cs
WHERE cs.CustomerCode NOT IN (SELECT CustomerDim.CustomerCode FROM CustomerDim)
INSERT INTO AuditEvents (BatchID, PackageName, StepName, 
	AdditionalInformation, RowsComplete)
	VALUES (@BatchID, 'UpdateCustomerDim', 'InsertNewCustData', 'Completed', @@Rowcount)

