--creates stored procedure that detects and inserts adds rows that could not be added to SalesFact table 
USE SBS_OLAP
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.SalesFactErrorRowsSP') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.SalesFactErrorRowsSP
GO
CREATE PROCEDURE dbo.SalesFactErrorRowsSP 
	@BatchID INT
AS
INSERT INTO dbo.SalesFactErrorRows
	(ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, BatchID, ErrorReason)
  SELECT ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, @BatchID,'Missing CustomerCode Value'
  FROM dbo.SalesStage WHERE SalesStage.CustomerCode NOT IN
    (SELECT SalesStage.CustomerCode FROM dbo.SalesStage
    INNER JOIN dbo.CustomerDim ON CustomerDim.CustomerCode = SalesStage.CustomerCode)

INSERT INTO dbo.SalesFactErrorRows
	(ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, BatchID, ErrorReason)
  SELECT ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, @BatchID,'Missing ProductCode Value'
  FROM dbo.SalesStage WHERE SalesStage.ProductCode NOT IN
    (SELECT SalesStage.ProductCode from SalesStage
    INNER JOIN dbo.ProductDim ON ProductDim.ProductCode = SalesStage.ProductCode)

INSERT INTO SalesFactErrorRows
	(ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, BatchID, ErrorReason)
SELECT 	ProductCode, CustomerCode, OrderDate, QuantitySales
	,AmountSales, @BatchID, 'Missing OrderDate Value'
  FROM SalesStage WHERE SalesStage.OrderDate NOT IN
    (SELECT SalesStage.OrderDate from SalesStage
    INNER JOIN TimeDim ON TimeDim.FullDateCode = SalesStage.OrderDate)

