USE SBS_OLAP
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[LoadSalesFactTable]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[LoadSalesFactTable]
GO
CREATE PROCEDURE dbo.LoadSalesFactTable 
	@BatchID INT
	,@PackageName NVARCHAR(100)
AS
INSERT INTO dbo.SalesFact 
	(ProductKey
	,CustomerKey
	,TimeKey
	,QuantitySales
	,AmountSales
	,BatchID)
  SELECT ProductDim.ProductKey
	,CustomerDim.CustomerKey
	,TimeDim.TimeKey
	,SalesStage.QuantitySales
	,SalesStage.AmountSales
	,@BatchID
  FROM dbo.TimeDim INNER JOIN dbo.ProductDim 
	INNER JOIN dbo.CustomerDim
	INNER JOIN dbo.SalesStage 
	ON CustomerDim.CustomerCode = SalesStage.CustomerCode
	ON ProductDim.ProductCode = SalesStage.ProductCode
	ON TimeDim.FullDateCode = SalesStage.OrderDate
INSERT INTO dbo.AuditEvents
	(BatchID
	,PackageName
	,StepName, 
	AdditionalInformation
	,RowsComplete)
	VALUES 
	(@BatchID
	,@PackageName
	,'Load SalesFact Table'
	,'Success'
	,@@Rowcount)


